"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UUID4 = void 0;
const id_base_1 = require("../../core/id.base");
const uuid_1 = require("uuid");
class UUID4 extends id_base_1.IdBase {
    validateValue(value) {
        if (!(0, uuid_1.validate)(value))
            throw new Error("Value is invalid UUID");
        if ((0, uuid_1.version)(value) !== 4)
            throw new Error("Value must be UUID version 4");
    }
    nextValue() {
        return (0, uuid_1.v4)();
    }
    compareValue(firstId, secondId) {
        return firstId === secondId;
    }
}
exports.UUID4 = UUID4;
