import { Type } from "../types/type";
export declare abstract class IdBase<I> {
    private _value;
    constructor(value?: I);
    static isId(obj: any): obj is AnyId;
    get value(): I;
    private setValue;
    abstract validateValue(value: I): void;
    abstract nextValue(): I;
    abstract compareValue(firstId: I, secondId: I): boolean;
    equalsType(id: IdBase<I>): boolean;
    equals(id: IdBase<I>): boolean;
    clone(): IdBase<I>;
}
export type AnyId = IdBase<any>;
export type TypeId<T extends AnyId = AnyId> = Type<T>;
export type GetIdValueType<T extends AnyId> = T extends IdBase<infer V> ? V : any;
