"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IdBase = void 0;
class IdBase {
    constructor(value) {
        this.setValue(value !== null && value !== void 0 ? value : this.nextValue());
    }
    static isId(obj) {
        return obj instanceof IdBase;
    }
    get value() {
        return this._value;
    }
    setValue(value) {
        if (this._value)
            return;
        this.validateValue(value);
        this._value = value;
    }
    equalsType(id) {
        return id instanceof this.constructor;
    }
    equals(id) {
        if (!this.equalsType(id))
            return false;
        return this.compareValue(this.value, id.value);
    }
    clone() {
        return new this.constructor(this.value);
    }
}
exports.IdBase = IdBase;
